stages:
    - build
    - test
    - deploy
    - production
    - docker
    - test docker

variables:
    URL_DOMAINE: http://formationgitlab_re
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_PIPELINE_IID
    IMAGE_TAG_LATEST: $CI_REGISTRY_IMAGE:latest

.default:
    image: node:14
    before_script:
        - npm ci --cache .npm --prefer-offline

.dummy:
    image: alpine:latest
    script:
        - echo "Yo!"

build:
    stage: build
    image: node:14
    script:
        - echo "Job build"
        - npm ci
        - npm run build
    artifacts:
        paths:
            - "public"


.test:
    stage: test
    image: alpine:latest
    before_script: []
    script:
        - echo "Job test"
        - grep "build something great" ./public/index.html
    dependencies: 
        - build

.test server:
    stage: test
    script:
        - npm run serve &
        - sleep 10
        - curl http://localhost:9000 | tac | tac | grep -q "build something great"
    dependencies:
        - build

.deploy test:
    stage: deploy
    before_script: []
    environment: 
        name: test
        url: $URL_DOMAINE.surge.sh
        on_stop: stop deploy test
    script:
        - npx surge --project ./public --domain $URL_DOMAINE.surge.sh/
    dependencies:
        - build

.stop deploy test:
    stage: deploy
    before_script: []
    environment:
        name: test
        action: stop
    only:
        - master
    script:
        - npx surge teardown $URL_DOMAINE.surge.sh/
    when: manual

.deploy prod:
    stage: production
    before_script: []
    when: manual
    environment: production
    only:
        - master
    script:
        - npx surge --project ./public --domain $URL_DOMAINE-product.surge.sh/
    dependencies:
        - build


image docker:
    stage: docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    script:
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker build -t $IMAGE_TAG -t $IMAGE_TAG_LATEST .
        - docker push $IMAGE_TAG
        - docker push $IMAGE_TAG_LATEST

test docker:
    stage: test docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    script:
        - apk add --update curl
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker pull $IMAGE_TAG
        - docker run -d -p 8080:80 --name website $IMAGE_TAG
        - sleep 10
        - curl http://docker:8080 | tac | tac | grep -q "build something great"



